<?php
/* © Kernel Video Sharing
   https://kernel-video-sharing.com
*/

ini_set('display_errors', 1);

echo '<!DOCTYPE html>
<html lang="en">
<head>
<title>KVS server requirements check</title>
</head>
<body>';

echo '<table cellspacing="10" cellpadding="5"><thead style="font-weight: bold; background: #eeeeee"><td>Library</td><td>Status</td></thead><tbody>';

$ffmpeg_result = [];
$ffmpeg_version = '';
$imagemagick_result = [];
$imagemagick_version = '';
$webp_support_version = '';
$wget_result = [];
$wget_version = '';

if (function_exists('exec'))
{
	exec('/usr/local/bin/ffmpeg -version', $ffmpeg_result);
	if (is_array($ffmpeg_result) && count($ffmpeg_result) > 0)
	{
		foreach ($ffmpeg_result as $line)
		{
			if (strpos($line, 'ffmpeg version') !== false)
			{
				$ffmpeg_version = $line;
				break;
			}
		}
	}
	if (!$ffmpeg_version)
	{
		exec('/usr/bin/ffmpeg -version', $ffmpeg_result);
		if (is_array($ffmpeg_result) && count($ffmpeg_result) > 0)
		{
			foreach ($ffmpeg_result as $line)
			{
				if (strpos($line, 'ffmpeg version') !== false)
				{
					$ffmpeg_version = $line;
					break;
				}
			}
		}
	}

	exec('/usr/local/bin/convert -version', $imagemagick_result);
	if (is_array($imagemagick_result) && count($imagemagick_result) > 0)
	{
		foreach ($imagemagick_result as $line)
		{
			if (strpos($line, 'Version:') !== false)
			{
				$imagemagick_version = substr($line, 8);
				$formats_list_result = [];
				exec('/usr/local/bin/convert -list format | grep WebP', $formats_list_result);
				if (is_array($formats_list_result) && count($formats_list_result) > 0)
				{
					foreach ($formats_list_result as $line2)
					{
						$pos = strpos($line2, 'WebP Image Format');
						if ($pos !== false && strpos($line2, 'rw') !== false)
						{
							$webp_support_version = substr($line2, $pos + 6);
							break;
						}
					}
				}
				break;
			}
		}
	}

	if (!$imagemagick_version)
	{
		exec('/usr/bin/convert -version', $imagemagick_result);
		if (is_array($imagemagick_result) && count($imagemagick_result) > 0)
		{
			foreach ($imagemagick_result as $line)
			{
				if (strpos($line, 'Version:') !== false)
				{
					$imagemagick_version = substr($line, 8);
					$formats_list_result = [];
					exec('/usr/bin/convert -list format | grep WebP', $formats_list_result);
					if (is_array($formats_list_result) && count($formats_list_result) > 0)
					{
						foreach ($formats_list_result as $line2)
						{
							$pos = strpos($line2, 'WebP Image Format');
							if ($pos !== false && strpos($line2, 'rw') !== false)
							{
								$webp_support_version = substr($line2, $pos);
								break;
							}
						}
					}
					break;
				}
			}
		}
	}

	exec('wget --version', $wget_result);
	if (is_array($wget_result) && count($wget_result) > 0)
	{
		foreach ($wget_result as $line)
		{
			if (strpos($line, 'GNU Wget') !== false)
			{
				$wget_version = $line;
				break;
			}
		}
	}
}

$ioncube_loader_version = 0;
$ioncube_loader_version_string = '';
if (function_exists('ioncube_loader_version'))
{
	$ioncube_loader_version = intval(ioncube_loader_version());
	$ioncube_loader_version_string = ioncube_loader_version();
}

echo '<tr><td><a target="_blank" href="https://www.ffmpeg.org">FFmpeg</a></td><td>' . ($ffmpeg_version ? '✔️ ' . $ffmpeg_version : (!function_exists('exec') ? '❓ Exec is disabled' : '❌ Not Installed (not required if you plan to use only embed codes)')) . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://imagemagick.org">ImageMagick</a></td><td>' . ($imagemagick_version ? '✔️ ' . $imagemagick_version : (!function_exists('exec') ? '❓ Exec is disabled' : '❌ Not Installed')) . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://imagemagick.org">ImageMagick WebP</a></td><td>' . ($webp_support_version ? '✔️ ' . $webp_support_version : (!function_exists('exec') ? '❓ Exec is disabled' : '⚠️ Recommended for better SEO')) . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.gnu.org/software/wget/">Wget</a></td><td>' . ($wget_version ? '✔️ ' . $wget_version : (!function_exists('exec') ? '❓ Exec is disabled' : '❌ Not Installed')) . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/supported-versions.php">PHP 8.1</a></td><td>' . (version_compare(PHP_VERSION, '8.1.0') >= 0 && version_compare(PHP_VERSION, '8.2.0') < 0 ? '✔️ ' : '❌ ') . PHP_VERSION . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.ioncube.com/loaders.php">PHP Ioncube loader 13.0+</a></td><td>' . ($ioncube_loader_version >= 13 ? '✔️ ' . $ioncube_loader_version_string : ($ioncube_loader_version == 0 ? '❌ Not Installed (not required if you buy open source code option)' : '❌ Old version: ' . $ioncube_loader_version_string)) . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.mysqli.php">PHP MySQL Improved Extension</a></td><td>' . (function_exists('mysqli_connect') ? '✔️ Installed' : '❌ Not Installed') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.curl.php">PHP Client URL Library</a></td><td>' . (function_exists('curl_init') ? '✔️ Installed' : '❌ Not Installed') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.zlib.php">PHP Zlib Compression</a></td><td>' . (function_exists('gzopen') ? '✔️ Installed' : '❌ Not Installed') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.simplexml.php">PHP SimpleXML</a></td><td>' . (function_exists('dom_import_simplexml') ? '✔️ Installed' : '❌ Not Installed') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.image.php">Image Processing and GD</a></td><td>' . (function_exists('imagecreatefromjpeg') ? '✔️ Installed' : '❌ Not Installed') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.mbstring.php">Multibyte String</a></td><td>' . (function_exists('mb_detect_encoding') ? '✔️ Installed' : '❌ Not Installed') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.json.php">JavaScript Object Notation</a></td><td>' . (function_exists('json_decode') ? '✔️ Installed' : '❌ Not Installed') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/book.memcached.php">Memcached</a></td><td>' . (class_exists('Memcached') ? '✔️ Enabled' : '⚠️ Recommended for faster performance') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/ini.core.php#ini.disable-functions">PHP.ini disable_functions: exec</a></td><td>' . (function_exists('exec') ? '✔️ Not restricted' : '❌ Restricted') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/ini.core.php#ini.disable-functions">PHP.ini disable_functions: escapeshellcmd</a></td><td>' . (function_exists('escapeshellcmd') ? '✔️ Not restricted' : '❌ Restricted') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/ini.core.php#ini.disable-functions">PHP.ini disable_functions: escapeshellarg</a></td><td>' . (function_exists('escapeshellarg') ? '✔️ Not restricted' : '❌ Restricted') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/ini.core.php#ini.file-uploads">PHP.ini fileuploads</a></td><td>' . (ini_get('file_uploads') ? '✔️ Enabled' : '❌ Disabled') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/ini.core.php#ini.post-max-size">PHP.ini post_max_size</a></td><td>' . (parse_ini_size(ini_get('post_max_size')) > 10000000 ? '✔️ ' : '❌ Less than 10M: ') . ini_get('post_max_size') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/ini.core.php#ini.upload-max-filesize">PHP.ini upload_max_filesize</a></td><td>' . (parse_ini_size(ini_get('upload_max_filesize')) > 10000000 ? '✔️ ' : '❌ Less than 10M: ') . ini_get('upload_max_filesize') . '</td></tr>';
echo '<tr><td><a target="_blank" href="https://www.php.net/manual/en/filesystem.configuration.php#ini.allow-url-fopen">PHP.ini allow_url_fopen</a></td><td>' . (ini_get('allow_url_fopen') ? '✔️ Enabled' : '❌ Disabled') . '</td></tr>';

echo '</tbody></table></body></html>';

function parse_ini_size(string $variable): int
{
	if (!$variable)
	{
		return 0;
	}

	$unit = strtoupper(substr($variable, -1));
	$value = intval($variable);

	switch ($unit)
	{
		case 'G':
			$value *= 1024 * 1024 * 1024;
			break;
		case 'M':
			$value *= 1024 * 1024;
			break;
		case 'K':
			$value *= 1024;
			break;
		default:
			break;
	}

	return $value;
}